import * as i0 from '@angular/core';
import { forwardRef, Directive, HostBinding, HostListener, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';

class CControl {
    constructor(stencilElement) {
        this.stencilElement = stencilElement;
        this.onChange = (value) => { };
        this.onTouched = () => { };
        const { nativeElement } = this.stencilElement;
        if (!nativeElement.tagName.toLowerCase().startsWith('c-')) {
            console.error('cControl ControlValueAccessor falsely used on non csc-ui component', nativeElement);
        }
    }
    writeValue(value) {
        this.hostValue = value;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    _handleChangeValue(value) {
        this.writeValue(value);
        this.onChange(value);
    }
}
CControl.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: CControl, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
CControl.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.3", type: CControl, selector: "[cControl]", host: { listeners: { "blur": "onTouched($event)", "changeValue": "_handleChangeValue($event.detail)" }, properties: { "value": "this.hostValue" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => CControl),
            multi: true,
        },
    ], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: CControl, decorators: [{
            type: Directive,
            args: [{
                    selector: '[cControl]',
                    host: { '(blur)': 'onTouched($event)' },
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => CControl),
                            multi: true,
                        },
                    ],
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { hostValue: [{
                type: HostBinding,
                args: ['value']
            }], _handleChangeValue: [{
                type: HostListener,
                args: ['changeValue', ['$event.detail']]
            }] } });

class CscUiAccessorModule {
}
CscUiAccessorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: CscUiAccessorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CscUiAccessorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: CscUiAccessorModule, declarations: [CControl], exports: [CControl] });
CscUiAccessorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: CscUiAccessorModule, imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: CscUiAccessorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [CControl],
                    imports: [],
                    exports: [CControl],
                }]
        }] });

/*
 * Public API Surface of csc-ui-accessor
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CControl, CscUiAccessorModule };
//# sourceMappingURL=csc-ui-accessor.mjs.map
